/*  bits.h  */

#if !defined BITS_DEF
#define BITS_DEF

#include "ints.h"

/* 
   REMOVE_BADBITS(x,bad)  should be equivalent to  while (x & bad) x--;
*/

#if !defined REMOVE_BADBITS
#if 0
#define REMOVE_BADBITS(x,y) \
{ uint16 RMBAUX=(x & y); /*if (RMBAUX)*/ { x ^= RMBAUX; x |= bittbl[RMBAUX] & ~y; } }
#else
#define REMOVE_BADBITS(x,y) \
{ uint8 RMBX = (x & y), RMBY; \
if (RMBX) { if ((RMBY = (RMBX & 0xf0))) RMBX = RMBY;\
if ((RMBY = (RMBX & 0xcc))) RMBX = RMBY; \
if ((RMBY = (RMBX & 0xaa))) RMBX = RMBY;\
x |= RMBX - 1;\
x &= ~y; } } 
#endif
#endif

extern int16 bittbl[];

void init_bits(int maxdegree);

#endif
