/* modseqno.h   --   sequence number of stops in modules */

#if !defined MODSEQNO_DEF
#define MODSEQNO_DEF

#include "seqno.h"
#include "modules.h"

typedef struct {
   module *mod;
   int tdegree;
   int numgens;
   int totdim;
   int dims[MAXGENS];
} modinfo;

void make_modinfo(modinfo *mi, module *m, int t);

int module_seqno(stop *s, modinfo *mi); /* sequence number of *s in *mi */
int module_seqno_with_degree(stop *s, modinfo *mi, int deg); 

#endif
